<template>
  <div class="issue-table">
    <Layout>
      <h1 v-if="version">{{version}}</h1>
      <Input search
             enter-button
             v-on:on-search="filter"
             placeholder="search in selection" />
      <Button type="primary"
              size="large"
              @click="exportData()">
        <Icon type="ios-download-outline"></Icon>Export Table
      </Button>
    </Layout>
    <Table size="large"
           :columns="columns"
           :data="table_data"
           :row-class-name="importantRow"
           ref="table"
           @on-sort-change="naturalSort">
      <template slot-scope="{ row }"
                slot="name">
        <strong>{{row.name}}</strong>
      </template>
      <template slot-scope="{ row, index }"
                slot="action">
        <Button type="primary"
                size="small"
                @click="show(index)">Details</Button>
      </template>
    </Table>
    <Modal v-model="modal"
           width="95">
      <p slot="header"><span>{{this.currentTicket}}</span></p>
      <div class="ticket-wrapper">
        <div class="ticket-description"
             v-if="currentTicketDescription">
          <h2>Description</h2>
          <span v-html="currentTicketDescription">
          </span>
        </div>
        <div class="ticket-implementation"
             v-if="currentTicketImplementation">
          <h2>Implementation</h2>
          <span v-html="currentTicketImplementation">
          </span>
        </div>
        <div class="ticket-parameterization"
             v-if="currentTicketParameterization">
          <h2>Parameterization</h2>
          <span v-html="currentTicketParameterization">
          </span>
        </div>
        <div class="ticket-influences"
             v-if="currentTicketInfluences">
          <h2>Parameterization</h2>
          <span v-html="currentTicketInfluences">
          </span>
        </div>
      </div>
      <div slot="footer">
        <Button type="info"
                size="large"
                long
                @click="close">Close</Button>
      </div>
    </Modal>
  </div>
</template>
<script>
const IssueExpand = () =>
  import(/* webpackChunkName: "issueexpand" */ "@/components/IssueExpand")

export default {
  name: "IssueTable",
  props: ["version", "issues", "fullTextSearch"],
  data: () => ({
    columns: [
      {
        type: "expand",
        width: 25,
        render: (h, params) => {
          return h(IssueExpand, {
            props: {
              row: params.row
            }
          })
        }
      },
      {
        width: 120,
        title: "Issue",
        key: "key",
        sortable: "custom"
      },
      { width: 120, title: "Type", key: "issuetype", sortable: true },
      {
        title: "Summary",
        key: "summary"
      },
      {
        title: "More",
        slot: "action",
        width: 100,
        align: "center"
      }
    ],
    exportColumns: [
      {
        title: "Issue",
        key: "key"
      },
      {
        title: "Summary",
        key: "summary"
      },
      {
        title: "Description",
        key: "description"
      },
      {
        title: "Implementation",
        key: "implementation"
      },
      {
        title: "Parameterization",
        key: "parameterization"
      },
      {
        title: "Influences",
        key: "influences"
      }
    ],
    table_data: [],
    table_data_unfiltered: [],
    modal: false,
    currentTicket: null,
    currentTicketDescription: null,
    currentTicketParameterization: null,
    currentTicketImplementation: null,
    currentTicketInfluences: null
  }),
  methods: {
    exportData() {
      if (this.fullTextSearch) {
        this.$refs.table.exportCsv({
          original: false,
          columns: this.columns.filter((col, index) => index > 0 && index < 5),
          data: this.table_data,
          separator: ";",
          quoted: true
        })
      } else {
        this.$refs.table.exportCsv({
          original: false,
          columns: this.columns.filter((col, index) => index > 0 && index < 4),
          data: this.table_data,
          separator: ";",
          quoted: true
        })
      }
    },
    importantRow(row) {
      if (row.parameterization || row.influences) {
        return "important-row"
      }
      return ""
    },
    show(index) {
      this.currentTicket = this.table_data[index].key
      this.currentTicketDescription = this.table_data[index].description
      this.currentTicketParameterization = this.table_data[
        index
      ].parameterization
      this.currentTicketImplementation = this.table_data[index].implementation
      this.currentTicketInfluences = this.table_data[index].influences
      this.modal = true
    },
    close() {
      this.modal = false
    },
    naturalSort(event) {
      if (event.key === "key") {
        if (event.order === "asc") {
          this.table_data = this.table_data.sort(this.compareKey)
        } else {
          this.table_data = this.table_data.sort(this.compareKey).reverse()
        }
      }
    },
    compareKey(a, b) {
      let reA = /[^a-zA-Z]/g
      let reN = /[^0-9]/g

      let aA = a.key.replace(reA, "")
      let bA = b.key.replace(reA, "")

      if (aA === bA) {
        let aN = parseInt(a.key.replace(reN, ""), 10)
        let bN = parseInt(b.key.replace(reN, ""), 10)
        return aN === bN ? 0 : aN > bN ? 1 : -1
      } else {
        return aA > bA ? 1 : -1
      }
    },
    filter(searchTerm) {
      let temp_s = searchTerm.toLowerCase()
      let temp_array = []

      const iter = this.table_data_unfiltered.values()
      let entry = Object
      while (!(entry = iter.next()).done) {
        if (
          entry.value.key.toLowerCase().includes(temp_s) ||
          entry.value.description.toLowerCase().includes(temp_s) ||
          entry.value.implementation.toLowerCase().includes(temp_s) ||
          entry.value.influences.toLowerCase().includes(temp_s) ||
          entry.value.issuetype.toLowerCase().includes(temp_s) ||
          entry.value.parameterization.toLowerCase().includes(temp_s) ||
          entry.value.summary.toLowerCase().includes(temp_s)
        ) {
          temp_array.push(entry.value)
        }
      }
      this.table_data = temp_array
    }
  },
  mounted() {
    if (this.fullTextSearch) {
      this.columns.splice(1, 0, {
        width: 150,
        title: "Version",
        key: "fixVersion",
        sortable: true
      })
    }
    this.table_data = this.issues.map(issue => {
      let rIssues = {}
      rIssues.fixVersion = issue.fields.fixVersions[0].name
      rIssues.key = issue.key
      rIssues.summary = issue.fields.summary
      rIssues.issuetype = issue.fields.issuetype.name
      rIssues.description = issue.renderedFields.description
      rIssues.implementation = issue.renderedFields.customfield_10082
      rIssues.parameterization = issue.renderedFields.customfield_10099 // !
      rIssues.influences = issue.renderedFields.customfield_10100 // !
      return rIssues
    })
    // We make copy of array, me no likey refs
    this.table_data_unfiltered = JSON.parse(JSON.stringify(this.table_data))
  }
}
</script>
<style>
.ivu-table .important-row td {
  color: red;
}
</style>
<style scoped>
.issue-table {
  padding-left: 20px;
  padding-right: 20px;
}
.ticket-wrapper >>> ul {
  list-style-type: disc;
  list-style-position: inside;
}
</style>
